#ifndef AINetworkVerifier_h
#define AINetworkVerifier_h

#include <Airport/Airport.h>

class StartupLocationMapObject;
class AINetworkVertex;
class MapEditor;

class AINetworkVerifier {
public:
	AINetworkVerifier(Airport::SmartRef airport, MapEditor* editor);
        virtual ~AINetworkVerifier();
        
        void VerifyAINetwork();
        
        Airport::SmartRef GetAirport() const { return _airport; }
        MapEditor* GetEditor() const { return _editor; }
protected:

        bool CheckHasRunwayPoints();
        bool CheckDuplicateArcs();
        bool CheckParkingRunwayRouting();
        bool SetPushbackRoutes();
        bool findShortestRoute(AINetworkVertex* start, AINetworkVertex* end);
        int setPushbackRoute(StartupLocationMapObject* start, AINetworkVertex* end);
        
        Airport::SmartRef _airport;
        MapEditor* _editor;
};

#endif

