#include "StartupLocationHeadingHandle.h"

#include "StartupLocationSelection.h"

#include <Map/MapEditor.h>
#include <Map/MapProjection.h>

IMPLEMENT_CLASS(StartupLocationHeadingHandle,MapSelectionHandle);

StartupLocationHeadingHandle::StartupLocationHeadingHandle(StartupLocationSelection* selection):
        MapSelectionHandle(selection)
{
}

StartupLocationHeadingHandle::~StartupLocationHeadingHandle()
{
}

void StartupLocationHeadingHandle::StartDrag(Point3D currentPosition) {
        Point3D center=GetSelection()->GetContent()->GetPosition();
        MapProjection* proj=GetSelection()->GetSelectionManager()->GetEditor()->GetProjection();
        
        Point3D localcenter=proj->ConvertToLocal(center);
        MapAngleDraggable::SetCenter(localcenter);
        MapAngleDraggable::StartDrag(currentPosition);
}

void StartupLocationHeadingHandle::Drag(Point3D currentPosition) {
        MapAngleDraggable::Drag(currentPosition);
}

wxString StartupLocationHeadingHandle::EndDrag() {
        // FIXME: should delete this object now
        return wxT("Changing startup position heading");
}

void StartupLocationHeadingHandle::AngleDrag(float delta) {
        float heading=GetSelection()->GetContent()->GetHeading();
        // The delta is positive ccw, but heading grows cw
        heading-=delta;
        if (heading<0.0)
                heading+=360.0;
        if (heading>=360.0)
                heading-=360.0;
        GetSelection()->GetContent()->SetHeading(heading);
}

