#ifndef PavementSelectionSideHandle_h
#define PavementSelectionSideHandle_h

// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif
#include <Map/MapSelectionHandle.h>

class PavementSelectionSideHandle: public MapSelectionHandle {
        
        DECLARE_CLASS(PavementSelectionSideHandle)
        
public:
	PavementSelectionSideHandle(MapSelection* selection, unsigned int side);
        virtual ~PavementSelectionSideHandle();
        
        virtual void StartDrag(Point3D currentPosition);
        
        virtual void Drag(Point3D currentPosition);
        
        virtual wxString EndDrag();
protected:
        void StartDrag(Point3D startPosition, const Point3D* corners, int offset);
        double GetNewLength(Point3D currentPosition,
                            const Point3D* corners,
                            int offset,
                            Point3D localcenters[2]);
        
        Point3D _handleDelta;
        unsigned int _side;
};

#endif

