#ifndef PointObjectSelection_h
#define PointObjectSelection_h

// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif

#include <Map/MapSelection.h>

#include <Map/MapDeltaDraggable.h>

#include "PointMapObject.h"

class PointObjectSelection: public MapSelection, public MapDeltaDraggable {
        
        DECLARE_CLASS(PointObjectSelection)
        
public:
        /* Construct a selection in the given selection manager with
         * the given content. Automatically attaches itself to the
         * selection manager and registers the selection as lifetime
         * observer on the content object.
         * May only be called from appropriate content object */
	PointObjectSelection(MapSelectionManager* manager, PointMapObject* content);
        
        /* May only be called from owning MapSelectionManager */
        virtual ~PointObjectSelection();
        
        virtual void StartDrag(Point3D currentPosition) { MapDeltaDraggable::StartDrag(currentPosition); }
        
        virtual void Drag(Point3D currentPosition) { MapDeltaDraggable::Drag(currentPosition); }
        
        virtual void DeltaDrag(Point3D delta);
        
        virtual void ProvidePropertiesForClass(wxPropertyGrid* propgrid, wxClassInfo* targetClass);
        
        virtual void UpdatePropertiesForClass(wxPropertyGrid* propgrid, wxClassInfo* targetClass);
        
        virtual void MarkDifferingPropertiesForClass(wxPropertyGrid* propgrid, wxClassInfo* targetClass, MapSelection* firstSelection);
        
        virtual void UpdateObjectFromProperty(wxPGProperty* property);

        /* Convenience override */
        PointMapObject* GetContent() const { return wxDynamicCast(MapSelection::GetContent(),PointMapObject); }
};

#endif


