#ifndef TowerMapObject_h
#define TowerMapObject_h

// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif

#include <Airport/PointMapObject.h>

class TowerMapObject: public PointMapObject {
        
        DECLARE_CLASS(TowerMapObject)
        TRANSACTIONOBJECT_DEFINE_SMARTREF(TowerMapObject);
        
public:
        /* Create a new object */
	TowerMapObject(TransactionManager* transactionManager,
                       Point3D position,
                       float height,
                       bool drawTower,
                       wxString name);
        
        virtual MapSelection* CreateSelection(MapSelectionManager* manager);
        
        TRANSACTIONOBJECT_DEFINE_STATE_ACCESSOR_WCOMP(float,Height,_height)
        TRANSACTIONOBJECT_DEFINE_STATE_ACCESSOR_WCOMP(bool,DrawTower,_drawTower)
        TRANSACTIONOBJECT_DEFINE_STATE_ACCESSOR_WUCOMP(wxString,Name,_name,
                                        TRANSACTIONOBJECT_STATEVAR(_name).Cmp(v)==0)
protected:
        typedef struct {
                float _height;
                bool _drawTower;
                wxString _name;
        } State;
        
        TRANSACTIONOBJECT_DEFINE_STATE_MEMENTO(TowerMapObject,PointMapObject,State)
};

#endif

