#ifndef MapSimpleBackgroundImageSelection_h
#define MapSimpleBackgroundImageSelection_h

// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif
#include <Map/MapSelection.h>
#include <Map/MapDeltaDraggable.h>
#include "MapSimpleBackgroundImage.h"


class MapSimpleBackgroundImageSelection: public MapSelection,
                                         public MapDeltaDraggable {
        
        DECLARE_CLASS(MapSimpleBackgroundImageSelection)
        
public:
	MapSimpleBackgroundImageSelection(MapSelectionManager* manager, MapSimpleBackgroundImage* content);

        virtual ~MapSimpleBackgroundImageSelection();
        
        virtual MapSelectionHandle* HitHandle(Point3D p);
        
        virtual wxRect GetDeviceBounds() const;

        virtual void StartDrag(Point3D currentPosition) {
                MapDeltaDraggable::StartDrag(currentPosition);
        }
        
        virtual void Drag(Point3D currentPosition) {
                MapDeltaDraggable::Drag(currentPosition);
        }
        
        virtual void DeltaDrag(Point3D delta);
        
        virtual wxString EndDrag();
        
        virtual void Paint(wxDC& dc);
        
        virtual void ProvidePropertiesForClass(wxPropertyGrid* propgrid, wxClassInfo* targetClass);
        
        virtual void UpdatePropertiesForClass(wxPropertyGrid* propgrid, wxClassInfo* targetClass);
        
        virtual void MarkDifferingPropertiesForClass(wxPropertyGrid* propgrid, wxClassInfo* targetClass, MapSelection* firstSelection);
        
        virtual void UpdateObjectFromProperty(wxPGProperty* property);

        MapSimpleBackgroundImage* GetContent() const { return wxDynamicCast(MapSelection::GetContent(),MapSimpleBackgroundImage); }
protected:
        void PaintHandles(wxDC& dc);
};

#endif


