#include "MapUSGSImage.h"

#include "USGSFetcher.h"
#include "MapUSGSImageLayer.h"

#include <Map/MapSelection.h>

#include <wx/listimpl.cpp>
WX_DEFINE_LIST(MapUSGSImageList);

IMPLEMENT_CLASS(MapUSGSImage,MapSimpleBackgroundImage)

MapUSGSImage::MapUSGSImage(TransactionManager* transactionManager,
                           MapUSGSImageLayer::ThemeType type,
                           int scale,
                           int x,
                           int y,
                           int zone):
        MapSimpleBackgroundImage(transactionManager,
                                 MapUSGSImageLayer::GetNorthWestPosForTile(zone,scale,x,y),
                                 MapUSGSImageLayer::GetResolutionForScale(scale)),
        type(type),
        scale(scale),
        x(x),
        y(y),
        zone(zone)
{
}

MapUSGSImage::~MapUSGSImage() {
}

MapSelection* MapUSGSImage::CreateSelection(MapSelectionManager* manager) {
        return new MapSelection(manager,this);
}


