#ifndef MapUSGSImage_h
#define MapUSGSImage_h

// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif

#include "MapSimpleBackgroundImage.h"
#include "MapUSGSImageLayer.h"

class MapUSGSImage: public MapSimpleBackgroundImage {
        
        DECLARE_CLASS(MapUSGSImage)
        TRANSACTIONOBJECT_DEFINE_SMARTREF(MapUSGSImage);
        
        friend class MapUSGSImageLayer;
        
public:
        virtual ~MapUSGSImage();
        
        virtual MapSelection* CreateSelection(MapSelectionManager* manager);
        
        MapUSGSImageLayer::ThemeType GetType() const { return type; }
        int GetScale() const { return scale; }
        int GetX() const { return x; }
        int GetY() const { return y; }
        int GetZone() const { return zone; }
protected:
	MapUSGSImage(TransactionManager* transactionManager,
                     MapUSGSImageLayer::ThemeType type,
                     int scale,
                     int x,
                     int y,
                     int zone);
        
        MapUSGSImageLayer::ThemeType type;
        int scale;
        int x;
        int y;
        int zone;
};

WX_DECLARE_LIST(MapUSGSImage,MapUSGSImageList);

#endif

