#include "ProjectWizard.h"

#include "MapFrame.h"

#include <Airport/Airport.h>
#include <IO/OldProjectLoader.h>
#include <IO/XPlaneLoader.h>
#include <Map/MapEditor.h>
#include <Map/MapProjection.h>
#include <Math/TDRectangle.h>

#include <wx/config.h>
#include <wx/filename.h>

#include <fstream>

IMPLEMENT_CLASS(ProjectWizard,wxWizard);

BEGIN_EVENT_TABLE(ProjectWizard,wxWizard)
END_EVENT_TABLE()

ProjectWizard::ProjectWizard() {
}
ProjectWizard::ProjectWizard(wxWindow* parent,
                             int id,
                             const wxString& title,
                             const wxBitmap& bitmap,
                             const wxPoint& pos,
                             long style)
{
        Create(parent,id,title,bitmap,pos,style);
}

ProjectWizard::~ProjectWizard() {
}

bool ProjectWizard::Create(wxWindow* parent,
                           int id,
                           const wxString& title,
                           const wxBitmap& bitmap,
                           const wxPoint& pos,
                           long style)
{
        if (!wxWizard::Create(parent,id,title,bitmap,pos,style))
                return false;
        
        _newAirportPage=new ProjectWizardNewAirportPage(this);
        _newProjectPage=new ProjectWizardNewProjectPage(this);
        _openProjectPage=new ProjectWizardOpenProjectPage(this);
        _typePage=new ProjectWizardTypePage(this,
                                            _newAirportPage,
                                            _newProjectPage,
                                            _openProjectPage);
        _newAirportPage->SetPrev(_typePage);
        _newProjectPage->SetPrev(_typePage);
        _openProjectPage->SetPrev(_typePage);
        
        GetPageAreaSizer()->Add(_newAirportPage);
        GetPageAreaSizer()->Add(_newProjectPage);
        GetPageAreaSizer()->Add(_openProjectPage);
        GetPageAreaSizer()->Add(_typePage);
        
        return true;
}

