#ifndef MapProjectionMenuManager_h
#define MapProjectionMenuManager_h

// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif

WX_DECLARE_STRING_HASH_MAP(int,MapProjectionToIDMap);
WX_DECLARE_HASH_MAP(int,wxString,wxIntegerHash,wxIntegerEqual,MapProjectionFromIDMap);

class MapProjectionMenuManager: public wxEvtHandler {
        
        DECLARE_CLASS(MapProjectionMenuManager)
        
public:
        virtual ~MapProjectionMenuManager();

        static MapProjectionMenuManager* GetInstance() {
                if (!_instance)
                        _instance=new MapProjectionMenuManager();
                return _instance;
        }
        
        static void UpdateMenu(wxMenu* menu);
        
        void OnProjectionSelected(wxCommandEvent& evt);
protected:
	MapProjectionMenuManager();

        static MapProjectionMenuManager* _instance;
        static MapProjectionToIDMap _descriptorToID;
        static MapProjectionFromIDMap _descriptorFromID;
};

#endif

